require "nokogiri"
require "cat_engine/config"

module CatEngine
  class FlatEngine
    def initialize full_history = []
      self.full_history = full_history
    end
    attr_accessor :id, :full_history

    def process id, history
      self.id = id

      doc = Nokogiri.parse(form)
      item = doc.root.css("Item").reject do |item|
        full_history.include?(item["FormItemOID"])
      end.first

      doc.root.children.each(&:unlink)
      if item
        item.parent = doc.root
      else
        doc.root = doc.create_element("Results")
      end

      doc
    end

    def valid_history? id, history
      true
    end

    private

    def form
      File.read("#{CatEngine.cat_path}/forms/#{id}.xml")
    end
  end
end

