﻿
namespace CORE.Engines
{
	using System;
	using System.Xml;

	public interface IEngine
	{

		XmlDocument getCurrentItem();
		XmlDocument getPreviousItem();
		XmlDocument getNextItem();
		XmlDocument getForm();


		void updateNode(XmlNode node);
		bool loadItems(XmlDocument doc, XmlDocument FormParams, bool WithHeader);

		void decrementPosition();
		void incrementPosition();
		void rollbackPosition();

		bool finished
		{
			get;
		}
		bool IsCompleted
		{
			get;
		}
		bool IsResume
		{
			get;
		}
		int currentPosition
		{
			get;
			set;
		}
		int previousPosition
		{
			get;
			set;
		}

		int TotalItems
		{
			get;
		}

		string message
		{
			get;
			set;
		}

		string paramPROC
		{
			get;
		}


	}

}