namespace CORE.Engines
{
  using System;
  using System.Xml;

  public class ShellWrapper
  {
    static void Main(string[] args)
    {
      // get form id from command line args
      string formID = args[0];

      XmlDocument doc = new XmlDocument();
      doc.Load("forms/" + formID + ".xml");

      XmlDocument formParams = new XmlDocument();
      formParams.Load("parameters/" + formID + ".xml");

      CATEngine3 e = new CATEngine3();
      e.loadItems(doc, formParams, true);
      
      // get answers from command line args if they exist
      string responseID = "";
      for(int i = 1; i < args.Length; i++) {
        responseID = args[i];
        XmlDocument nextItem = e.getNextItem();
        XmlElement item = (XmlElement)nextItem.GetElementsByTagName("Item")[0];
        item.SetAttribute("ItemResponseOID", responseID);
        // item.Attributes["Response"].Value = responseID;
        // item.Attributes["ResponseTime"].Value = "10";
        e.updateNode(item);
      }
      
      if(e.finished) {
        double theta = e.ThetaHistory[e.ThetaHistory.Length - 1];
        double stdError = e.StdErrorHistory[e.StdErrorHistory.Length - 1];
        Console.WriteLine("<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<Results Theta=\"" + theta + "\" StdError=\"" + stdError + "\" />");

      } else {
        e.getCurrentItem().Save(Console.Out);
      }
    }
  }
}
